public class ExceptionsDemo {
    public static void main(String[] args) throws NumberReadException
    {
        // three possible scenarions when launching this pg: 
        // 1. cmd line parameter given AND it is a string containing number
        // 2. cmd line parameter given but it does not contain number
        // 3. no parameter given
            // here only in case 1
        System.out.println("i=" + readNumber(args));
            
        System.out.println("Program finished");
    }
    
    public static int readNumber(String[] args) {
        try {
            String s = args[0];
            int i = Integer.parseInt(s);
            return i;
         
        } catch(ArrayIndexOutOfBoundsException e) {
            // here if no parameter given (case 3)
            System.out.println("ArrayIndexOutOfBoundsException");
            return 0;
            
        } finally {
            System.out.println("Always here before method exits");
        }
    }
}
